// *** The Database Update Framework Include file for Languages ***
// Language constant declarations for all classes included in "DUF - The Database Update Framework"
// They have all been placed in this central spot to make translations to various languages more convenient.
//
Use LanguageText.Pkg

#IFSAME Language$Current Language$English
    // *** cSQLConnectionsIniFile.pkg Class Language Constants ***
    Define CS_DUF_DuplicateConnectionIDPre  for "Cannot register connection ID"
    Define CS_DUF_DuplicateConnectionIDPost for "This ID already exists."
    // *** cSQLConnectionsHandler.pkg Class Language Constants ***
    Define CS_DUF_SetupErrorcConnection     for "Cannot login to the database server as the cConnection hasn't been setup properly. Can't continue. Program will now exit."
    Define CS_DUF_CannotLoginToServer       for "Could not login to the database server. Can't continue. Program will now exit."
    Define CS_DUF_ErrorText                 for "\n\nError Text:"
    // *** cDbUpdateFunctionLibrary.pkg Class Language Constants ***
    Define CS_DUF_ConnectError              for "SQL error. Could not connect to the SQL database manager"
    Define CS_DUF_AttachError               for "Could not attach to the database:"
    Define CS_DUF_DeletingIndex             for "Deleting index"
    Define CS_DUF_CopyingData               for "Copying data"
    Define CS_DUF_CreatingIndex             for "Creating index"
    Define CS_DUF_LoginToDbServerFailed     for  "Login failed to the database server. The following connect string was used:\n"
    Define CS_DUF_DoYouWantToExit           for "Do you want to stop the database update and exit?"  
    Define CS_DUF_NoIntFilesFound           for "No .int files found! Nothing was changed."
    // *** cDbUpdateVersion.pkg Class Language Constants ***
    Define CS_DUF_UpdateVersion             for "Updating database"
    Define CS_DUF_UpdateFromVersion         for "from version"
    Define CS_DUF_UpdateToVersion           for "to version:"
    Define CS_DUF_DbUpdateTableMissing      for "Cannot open the 'DbVersion' table that is used when updating the database! Cannot continue!"
    // *** cDbUpdateHandler.inc Language Constants ***
    Define CS_DUF_DatabaseInUseShort        for "There are others using the application/database. Are you sure you still want to update the database?"
    Define CS_DUF_DatabaseNeedsUpdate       for ("The database needs to be updated." + "\n\nATTENTION! The database may not be in use while this work is performed. Make sure that nobody else is using the application before clicking 'Yes' below.\n\n" + "Start update now?")
    Define CS_DUF_HeaderUpdateText          for "Important!"
    Define CS_DUF_DatabaseInUseText         for "There are others using the application/database or at least one table could NOT be opened exclusively. Please close all other applications using the database and try again. The Application will now close."
    Define CS_DUF_WorkingHeaderText         for "Working!"
    Define CS_DUF_WorkingUpdateText         for "The database is being updated. Please wait..."
    Define CS_DUF_DatabaseUpdatedText       for "Ready! The database was updated."
    Define CS_DUF_DatabaseCheckedText       for "Ready! The database was checked but no updates was needed."
    Define CS_DUF_DbUpdatedErrorText        for "One or more errors occured while the database was updated. Please check the logfile.\n\nThe program will now close."
    Define CS_DUF_UpdateInProgressTxt       for ("System locked!\n\nThe database is being updated. Please try again later...\n\n" * "The program will now close.")
    // *** cDbUpdateHandler.pkg Class Language Constants ***
    Define CS_DUF_DatabaseConnStringSpec    for "The database specified in the connection string: '"
    Define CS_DUF_DatabaseDoesntExist       for "' doesn't exist!\n\nYou need to create it with a database management software or by using the 'SqlDatabaseCreate' function, which can be used in the 'OnPreUpdate' event of the cDbUpdateHandler object.\n\nThe program will now exit."
    // *** cDbUpdateLogFile.pkg Class Language Constants ***   
    Define CS_DUF_LogFileNotFound           for "Could not locate the log file:\n\n"
#ENDIF

#IFSAME Language$Current Language$Nederlands
    // *** cSQLConnectionsIniFile Class Language Constants ***
    Define CS_DUF_DuplicateConnectionIDPre  for "Kan de connection ID niet registreren"
    Define CS_DUF_DuplicateConnectionIDPost for "Deze ID bestaat al."
    // *** cSQLConnectionsHandler Class Language Constants ***
    Define CS_DUF_CannotLogincConnection    for "Kan niet inloggen op de databaseserver, omdat cConnection niet correct is ingesteld. Kan niet doorgaan. Het programma wordt beindigd."
    Define CS_DUF_CannotLoginToServer       for "Kan niet inloggen op de databaseserver. Kan niet doorgaan. Het programma wordt beindigd."
    Define CS_DUF_ErrorText                 for "\n\nFoutmelding:"
    // *** cDbUpdateFunctionLibrary Class Language Constants ***
    Define CS_DUF_ConnectError              for "SQL fout. Kon geen verbinding maken met de SQL database manager"
    Define CS_DUF_AttachError               for "Kan niet aan de database koppelen:"
    Define CS_DUF_DeletingIndex             for "Verwijderen index"
    Define CS_DUF_CopyingData               for "Kopiren data"
    Define CS_DUF_CreatingIndex             for "Aanmaken index"
    Define CS_DUF_LoginToDbServerFailed     for  "Login failed to the database server. The following connect string was used:\n"
    Define CS_DUF_DoYouWantToExit           for "Do you want to stop the database update and exit?"
    Define CS_DUF_NoIntFilesFound           for "No .int files found! Nothing was changed."
    // *** cDbUpdateVersion Class Language Constants ***
    Define CS_DUF_UpdateVersion             for "Bijwerken database"
    Define CS_DUF_UpdateFromVersion         for "van versie"
    Define CS_DUF_UpdateToVersion           for "naar versie:"
    Define CS_DUF_DbUpdateTableMissing for "Kan de 'DbVersion' tabel niet openen, die wordt gebruikt bij het bijwerken van de database! Kan niet doorgaan!"
    // *** cDbUpdateHandler.inc Class Language Constants ***
    Define CS_DUF_DatabaseInUseShort        for "There are others using the application/database. Are you sure you still want to update the database?"
    Define CS_DUF_DatabaseNeedsUpdate       for ("De database moet worden bijgewerkt." + "\n\nNB! De database mag niet in gebruik zijn, terwijl deze bewerking wordt uitgevoerd. Zorg ervoor dat niemand anders de toepassing gebruikt voordat u hieronder 'Ja' klikt.\n\n" + "Beginnen met bijwerken?")
    Define CS_DUF_HeaderUpdateText          for "Belangrijk!"
    Define CS_DUF_DatabaseInUseText         for "Er zijn anderen die de applicatie / database gebruiken of tenminste n tabel kan NIET exclusief geopend worden. Sluit alstublieft alle andere applicaties met behulp van de database en probeer het opnieuw. De applicatie zal nu sluiten."
    Define CS_DUF_WorkingHeaderText         for "Bezig!"
    Define CS_DUF_WorkingUpdateText         for "De database wordt bijgewerkt. Even geduld a.u.b. ..."
    Define CS_DUF_DatabaseUpdatedText       for "Klaar! De database is bijgewerkt."
    Define CS_DUF_DatabaseCheckedText       for "Klaar! De database is gecontroleerd, maar er waren geen updates nodig."
    Define CS_DUF_DbUpdatedErrorText        for "Er zijn n of meerdere fouten opgetreden tijdens het bijwerken van de database. Controleer het logbestand.\n\nHet programma wordt nu beindigd."
    Define CS_DUF_UpdateInProgressTxt       for ("Het systeem is vergrendeld!\n\nDe database wordt bijgewerkt. Probeer het later nogmaals...\n\n" * "Het programma wordt nu beindigd.")
    // *** cDbUpdateHandler.pkg Class Language Constants ***
    Define CS_DUF_DatabaseConnStringSpec    for "The database specified in the connection string: '"
    Define CS_DUF_DatabaseDoesntExist       for "' doesn't exist!\n\nYou need to create it with a database management software or by using the 'SqlDatabaseCreate' function, which can be used in the 'OnPreUpdate' event of the cDbUpdateHandler object.\n\nThe program will now exit."
    // *** cDbUpdateLogFile.pkg Class Language Constants ***   
    Define CS_DUF_LogFileNotFound           for "Could not locate the log file:\n\n"
#ENDIF

#IFSAME Language$Current Language$Svenska
    // *** cSQLConnectionsIniFile Class Language Constants ***
    Define CS_DUF_DuplicateConnectionIDPre  for "Kan inte registrera anslutnings-ID"
    Define CS_DUF_DuplicateConnectionIDPost for "Detta ID finns redan."
    // *** cSQLConnectionsHandler Class Language Constants ***
    Define CS_DUF_CannotLogincConnection    for "Kan inte logga in p databasservern drfr att en 'cConnection' inte har konfigurerats. Kan ej fortstta. Programmet kommer nu att avbrytas."
    Define CS_DUF_CannotLoginToServer       for "Kunde ej logga in till databasservern. Kan ej fortstta. Programmet kommer nu att avslutas."
    Define CS_DUF_ErrorText                 for "\n\nError Text:"
    // *** cDbUpdateFunctionLibrary Class Language Constants ***
    Define CS_DUF_ConnectError              for "SQL Fel. Kunde ej f kontakt med SQL Database Manager"
    Define CS_DUF_AttachError               for "Fick ej kontakt med databasen:"
    Define CS_DUF_DeletingIndex             for "Tar bort index"
    Define CS_DUF_CopyingData               for "Kopierar data"
    Define CS_DUF_CreatingIndex             for "Skapar index"
    Define CS_DUF_LoginToDbServerFailed     for "Login till databaservern misslyckades. Fljande inloggningsstrng anvndes vid frsket:\n"
    Define CS_DUF_DoYouWantToExit           for "Vill du avbryta databasuppdateringen och avsluta programmet?"
    Define CS_DUF_NoIntFilesFound           for "No .int files found! Nothing was changed."
    // *** cDbUpdateVersion Class Language Constants ***
    Define CS_DUF_UpdateVersion             for "Uppdaterar databas"
    Define CS_DUF_UpdateFromVersion         for "frn version"
    Define CS_DUF_UpdateToVersion           for "till version:"
    Define CS_DUF_DbUpdateTableMissing      for "Kan inte ppna 'DbVersion' tabellen som anvnds d databasen ska uppdateras! Kan inte fortstta!"
    // *** cDbUpdateHandler.inc Class Language Constants ***
    Define CS_DUF_DatabaseInUseShort        for "There are others using the application/database. Are you sure you still want to update the database?"
    Define CS_DUF_DatabaseNeedsUpdate       for ("Databasen behver uppdateras." + "\n\nOBS! Databasen fr ej anvndas medan detta arbete sker. Var god och skerstll att ingen annan kr programmet eller p annat stt anvnder databasen som anvnds fr programmet innan du klicka p 'Ja' nedan.\n\n" + "Starta uppdateringen nu?")
    Define CS_DUF_HeaderUpdateText          for "Viktigt!"
    Define CS_DUF_DatabaseInUseText         for "Det verkar finnas andra personer som kr programmet eller anvnder databasen, eftersom tminstone en tabell ej kunde ppnas exklusivt. Var vnlig stng alla andra applikationer som kan anvnda databasen och frsk igen. Programmet kommer nu att avslutas."
    Define CS_DUF_WorkingHeaderText         for "Arbetar!"
    Define CS_DUF_WorkingUpdateText         for "Databasen hller p att uppdateras. Var god vnta..."
    Define CS_DUF_DatabaseUpdatedText       for "Klart! Databasen r nu uppdaterad."
    Define CS_DUF_DatabaseCheckedText       for "Ready! The database was checked but no updates was needed."
    Define CS_DUF_DbUpdatedErrorText        for "Ett eller flera fel uppstod tyvrr under uppdateringen av databasen. Var god kontrollera fel-loggen.\n\nProgrammet kommer nu att avslutas."
    Define CS_DUF_UpdateInProgressTxt       for ("Systemet r lst!\n\nDatabasen hller p att uppdateras. Var god vnta och frsk ter senare...\n\n" * "Programmet kommer nu att avslutas.")
    // *** cDbUpdateHandler.pkg Class Language Constants ***
    Define CS_DUF_DatabaseConnStringSpec    for "The database specified in the connection string: '"
    Define CS_DUF_DatabaseDoesntExist       for "' doesn't exist!\n\nYou need to create it with a database management software or by using the 'SqlDatabaseCreate' function, which can be used in the 'OnPreUpdate' event of the cDbUpdateHandler object.\n\nThe program will now exit."
    // *** cDbUpdateLogFile.pkg Class Language Constants ***   
    Define CS_DUF_LogFileNotFound           for "Could not locate the log file:\n\n"
#ENDIF

#IFSAME Language$Current Language$Deutsch
    // *** cSQLConnectionsIniFile Class Language Constants ***
    Define CS_DUF_DuplicateConnectionIDPre  for "Kann Connection ID nicht registrieren"
    Define CS_DUF_DuplicateConnectionIDPost for "Dieses ID existiert schon."
    // *** cSQLConnectionsHandler Class Language Constants ***
    Define CS_DUF_CannotLogincConnection    for "Anmeldung am Datenbank-Server nicht mglich, die cConnection ist nicht richtig eingerichtet. Fortfahren nicht mglich. Das Programm wird beendet."
    Define CS_DUF_CannotLoginToServer       for "Anmeldung am Datenbank-Server nicht mglich. Fortfahren nicht mglich. Das Programm wird beendet."
    Define CS_DUF_ErrorText                 for "\n\nFehler Text:"
    // *** cDbUpdateFunctionLibrary Class Language Constants ***
    Define CS_DUF_ConnectError              for "SQL Fehler. Verbindung zum SQL Datenbank Manager nicht mglich."
    Define CS_DUF_AttachError               for "Verbindung zur Datenbank fehlgeschlagen:"
    Define CS_DUF_DeletingIndex             for "Index lschen"
    Define CS_DUF_CopyingData               for "Daten kopieren"
    Define CS_DUF_CreatingIndex             for "Index erstellen"
    Define CS_DUF_LoginToDbServerFailed     for  "Login failed to the database server. The following connect string was used:\n"
    Define CS_DUF_DoYouWantToExit           for "Do you want to stop the database update and exit?"
    Define CS_DUF_NoIntFilesFound           for "No .int files found! Nothing was changed."
    // *** cDbUpdateVersion Class Language Constants ***
    Define CS_DUF_UpdateVersion             for "Datenbank aktualisieren"
    Define CS_DUF_UpdateFromVersion         for "von Version"
    Define CS_DUF_UpdateToVersion           for "auf Version:"
    Define CS_DUF_DbUpdateTableMissing      for "Kann die Tabelle 'DbVersion' nicht ffnen, die zum Aktualisieren der Datenbank benutzt wird! Fortfahren nicht mglich!"
    // *** cDbUpdateHandler.inc Class Language Constants ***
    Define CS_DUF_DatabaseInUseShort        for "There are others using the application/database. Are you sure you still want to update the database?"
    Define CS_DUF_DatabaseNeedsUpdate       for ("Die Datenbank muss aktualisiert werden." + "\n\nNB! Die Datenbank darf whrend dieses Prozesses nicht in Benutzung sein. Stellen Sie sicher, dass niemand das Programm benutzt, bevor Sie unten 'Ja' klicken.\n\n" + "Jetzt starten?")
    Define CS_DUF_HeaderUpdateText          for "Wichtig!"
    Define CS_DUF_DatabaseInUseText         for "Andere Benutzer benutzen das Programm/die Datenbank. Zumindest eine Tabelle konnte nicht EXCLUSIV geffnet werden. Bitte schliessen Sie alle anderen Programme, die die Datenbank benutzen und versuchen Sie es erneut. Das Programm wir jetzt beendet."
    Define CS_DUF_WorkingHeaderText         for "Arbeite!"
    Define CS_DUF_WorkingUpdateText         for "Die Datenbank wird aktualisiert. Bitte warten..."
    Define CS_DUF_DatabaseUpdatedText       for "Fertig! Die Datenbank ist aktualisiert."
    Define CS_DUF_DatabaseCheckedText       for "Fertig! Die Datenbank wurde berprft, es ist aber keine Aktualisierung notwendig."
    Define CS_DUF_DbUpdatedErrorText        for "Ein oder mehrere Fehler sind whrend der Aktualisierung aufgetreten. Bitte schauen Sie in die Log-Datei.\n\nDas Programm wird jetzt beendet."
    Define CS_DUF_UpdateInProgressTxt       for ("System gesperrt!\n\nDie Datenbank wird aktualisiert. Bitte versuchen Sie es spter wieder...\n\n" * "Das Programm wird jetzt beendet.")
    // *** cDbUpdateHandler.pkg Class Language Constants ***
    Define CS_DUF_DatabaseConnStringSpec    for "The database specified in the connection string: '"
    Define CS_DUF_DatabaseDoesntExist       for "' doesn't exist!\n\nYou need to create it with a database management software or by using the 'SqlDatabaseCreate' function, which can be used in the 'OnPreUpdate' event of the cDbUpdateHandler object.\n\nThe program will now exit."
    // *** cDbUpdateLogFile.pkg Class Language Constants ***   
    Define CS_DUF_LogFileNotFound           for "Could not locate the log file:\n\n"
#ENDIF

#IFSAME Language$Current Language$Dansk
    // *** cSQLConnectionsIniFile Class Language Constants ***
    Define CS_DUF_DuplicateConnectionIDPre  for "Cannot register connection ID"
    Define CS_DUF_DuplicateConnectionIDPost for "This ID already exists."
    // *** cSQLConnectionsHandler Class Language Constants ***
    Define CS_DUF_CannotLogincConnection    for "Cannot login to the database server as the cConnection hasn't been setup properly. Can't continue. Program will now exit."
    Define CS_DUF_CannotLoginToServer       for "Could not login to the database server. Can't continue. Program will now exit."
    Define CS_DUF_ErrorText                 for "\n\nError Text:"
    // *** cDbUpdateFunctionLibrary Class Language Constants ***
    Define CS_DUF_ConnectError              for "SQL error. Could not connect to the SQL database manager"
    Define CS_DUF_AttachError               for "Could not attach to the database:"
    Define CS_DUF_DeletingIndex             for "Deleting index"
    Define CS_DUF_CopyingData               for "Copying data"
    Define CS_DUF_CreatingIndex             for "Creating index"
    Define CS_DUF_LoginToDbServerFailed     for  "Login failed to the database server. The following connect string was used:\n"
    Define CS_DUF_DoYouWantToExit           for "Do you want to stop the database update and exit?"
    Define CS_DUF_NoIntFilesFound           for "No .int files found! Nothing was changed."
    // *** cDbUpdateVersion Class Language Constants ***
    Define CS_DUF_UpdateVersion             for "Updating database"
    Define CS_DUF_UpdateFromVersion         for "from version"
    Define CS_DUF_UpdateToVersion           for "to version:"
    Define CS_DUF_DbUpdateTableMissing      for "Cannot open the 'DbVersion' table that is used when updating the database! Cannot continue!"
    // *** cDbUpdateHandler.inc Class Language Constants ***
    Define CS_DUF_DatabaseInUseShort        for "There are others using the application/database. Are you sure you still want to update the database?"
    Define CS_DUF_DatabaseNeedsUpdate       for ("The database needs to be updated." + "\n\nATTENTION! The database may not be in use while this work is performed. Make sure that nobody else is using the application before clicking 'Yes' below.\n\n" + "Start update now?")
    Define CS_DUF_HeaderUpdateText          for "Important!"
    Define CS_DUF_DatabaseInUseText         for "There are others using the application/database or at least one table could NOT be opened exclusively. Please close all other applications using the database and try again. The Application will now close."
    Define CS_DUF_WorkingHeaderText         for "Working!"
    Define CS_DUF_WorkingUpdateText         for "The database is being updated. Please wait..."
    Define CS_DUF_DatabaseUpdatedText       for "Ready! The database was updated."
    Define CS_DUF_DatabaseCheckedText       for "Ready! The database was checked but no updates was needed."
    Define CS_DUF_DbUpdatedErrorText        for "One or more errors occured while the database was updated. Please check the logfile.\n\nThe program will now close."
    Define CS_DUF_UpdateInProgressTxt       for ("System locked!\n\nThe database is being updated. Please try again later...\n\n" * "The program will now close.")
    // *** cDbUpdateHandler.pkg Class Language Constants ***
    Define CS_DUF_DatabaseConnStringSpec    for "The database specified in the connection string: '"
    Define CS_DUF_DatabaseDoesntExist       for "' doesn't exist!\n\nYou need to create it with a database management software or by using the 'SqlDatabaseCreate' function, which can be used in the 'OnPreUpdate' event of the cDbUpdateHandler object.\n\nThe program will now exit."
    // *** cDbUpdateLogFile.pkg Class Language Constants ***   
    Define CS_DUF_LogFileNotFound           for "Could not locate the log file:\n\n"
#ENDIF

#IFSAME Language$Current Language$Portugues
    // *** cSQLConnectionsIniFile Class Language Constants ***
    Define CS_DUF_DuplicateConnectionIDPre  for "No pde registar o ID de conexo"
    Define CS_DUF_DuplicateConnectionIDPost for "Este ID j existe."
    // *** cSQLConnectionsHandler Class Language Constants ***
    Define CS_DUF_CannotLogincConnection    for "No pde conectar-se ao servidor de banco de dados, pois o objeto cConnetion no fora configurado adequadamente. Impossvel continuar. Programa ser encerrado."
    Define CS_DUF_CannotLoginToServer       for "No pde conectar-se ao servidor de banco de dados. Impossvel continuar. Programa ser encerrado."
    Define CS_DUF_ErrorText                 for "\n\nDescrio do Erro:"
    // *** cDbUpdateFunctionLibrary Class Language Constants ***
    Define CS_DUF_ConnectError              for "Erro SQL. No foi possvel conectar-se ao gerenciador de banco de dados SQL"
    Define CS_DUF_AttachError               for "No foi possvel anexar-se ao banco de dados:"
    Define CS_DUF_DeletingIndex             for "Excluindo ndice"
    Define CS_DUF_CopyingData               for "Copiando dados"
    Define CS_DUF_CreatingIndex             for "Criando ndice"
    Define CS_DUF_LoginToDbServerFailed     for  "Login failed to the database server. The following connect string was used:\n"
    Define CS_DUF_DoYouWantToExit           for "Do you want to stop the database update and exit?"
    Define CS_DUF_NoIntFilesFound           for "No .int files found! Nothing was changed."
    // *** cDbUpdateVersion Class Language Constants ***
    Define CS_DUF_UpdateVersion             for "Atualizando banco de dados"
    Define CS_DUF_UpdateFromVersion         for "da verso"
    Define CS_DUF_UpdateToVersion           for "para a verso:"
    Define CS_DUF_DbUpdateTableMissing      for "No foi possiel abrir a tabela 'DbVersion' que  utilizada durante o processo de atualizao do banco de dados.! Impossvel continuar!"
    // *** cDbUpdateHandler.inc Class Language Constants ***
    Define CS_DUF_DatabaseInUseShort        for "There are others using the application/database. Are you sure you still want to update the database?"
    Define CS_DUF_DatabaseNeedsUpdate       for ("O banco de dados precisa ser atualizado." + "\n\nAteno! O banco de dados no pode ser utilizado enquanto essa tarefa  executada. Certifique-se de que ningum mais esteja utilizando a aplicao antes de clicar em 'Sim' abaixo.\n\n" + "Iniciar a atualizao agora?")
    Define CS_DUF_HeaderUpdateText          for "Importante!"
    Define CS_DUF_DatabaseInUseText         for "Existem outros usurios usando a aplicao/banco de dados ou pelo menos uma tabela no pde ser aberta em modo exclusivo. Por favor, encerre todas as aplicaes que usam esse banco de dados e tente novamente. Esse Aplicativo ser encerrado agora."
    Define CS_DUF_WorkingHeaderText         for "Trabalhando!"
    Define CS_DUF_WorkingUpdateText         for "O banco de dados est sendo atualizado. Por favor aguarde ..."
    Define CS_DUF_DatabaseUpdatedText       for "Pronto! O banco de dados foi atualizado."
    Define CS_DUF_DatabaseCheckedText       for "Pronto! O banco de dados foi verificado mas nenhuma atualizao era necessria."
    Define CS_DUF_DbUpdatedErrorText        for "Um ou mais erros aconteceram enquanto o banco de dados era atualizado. Por favor verifique o arquivo de log.\n\nO programa ser encerrado."
    Define CS_DUF_UpdateInProgressTxt       for ("Sistema bloqueado!\n\nO banco de dados est sendo atualizado. Por favor tente novamente mais tarde...\n\n" * "O programa ser encerrado.")
    // *** cDbUpdateHandler.pkg Class Language Constants ***
    Define CS_DUF_DatabaseConnStringSpec    for "The database specified in the connection string: '"
    Define CS_DUF_DatabaseDoesntExist       for "' doesn't exist!\n\nYou need to create it with a database management software or by using the 'SqlDatabaseCreate' function, which can be used in the 'OnPreUpdate' event of the cDbUpdateHandler object.\n\nThe program will now exit."
    // *** cDbUpdateLogFile.pkg Class Language Constants ***   
    Define CS_DUF_LogFileNotFound           for "Could not locate the log file:\n\n"
#ENDIF

#IFSAME Language$Current Language$Francais
    // *** cSQLConnectionsIniFile Class Language Constants ***
    Define CS_DUF_DuplicateConnectionIDPre  for "Cannot register connection ID"
    Define CS_DUF_DuplicateConnectionIDPost for "This ID already exists."
    // *** cSQLConnectionsHandler Class Language Constants ***
    Define CS_DUF_CannotLogincConnection    for "Cannot login to the database server as the cConnection hasn't been setup properly. Can't continue. Program will now exit."
    Define CS_DUF_CannotLoginToServer       for "Could not login to the database server. Can't continue. Program will now exit."
    Define CS_DUF_ErrorText                 for "\n\nError Text:"
    // *** cDbUpdateFunctionLibrary Class Language Constants ***
    Define CS_DUF_ConnectError              for "SQL error. Could not connect to the SQL database manager"
    Define CS_DUF_AttachError               for "Could not attach to the database:"
    Define CS_DUF_DeletingIndex             for "Deleting index"
    Define CS_DUF_CopyingData               for "Copying data"
    Define CS_DUF_CreatingIndex             for "Creating index"
    Define CS_DUF_LoginToDbServerFailed     for  "Login failed to the database server. The following connect string was used:\n"
    Define CS_DUF_DoYouWantToExit           for "Do you want to stop the database update and exit?"
    Define CS_DUF_NoIntFilesFound           for "No .int files found! Nothing was changed."
    // *** cDbUpdateVersion Class Language Constants ***
    Define CS_DUF_UpdateVersion             for "Updating database"
    Define CS_DUF_UpdateFromVersion         for "from version"
    Define CS_DUF_UpdateToVersion           for "to version:"
    Define CS_DUF_DbUpdateTableMissing      for "Cannot open the 'DbVersion' table that is used when updating the database! Cannot continue!"
    // *** cDbUpdateHandler.inc Class Language Constants ***
    Define CS_DUF_DatabaseInUseShort        for "There are others using the application/database. Are you sure you still want to update the database?"
    Define CS_DUF_DatabaseNeedsUpdate       for ("The database needs to be updated." + "\n\nATTENTION! The database may not be in use while this work is performed. Make sure that nobody else is using the application before clicking 'Yes' below.\n\n" + "Start update now?")
    Define CS_DUF_HeaderUpdateText          for "Important!"
    Define CS_DUF_DatabaseInUseText         for "There are others using the application/database or at least one table could NOT be opened exclusively. Please close all other applications using the database and try again. The Application will now close."
    Define CS_DUF_WorkingHeaderText         for "Working!"
    Define CS_DUF_WorkingUpdateText         for "The database is being updated. Please wait..."
    Define CS_DUF_DatabaseUpdatedText       for "Ready! The database was updated."
    Define CS_DUF_DatabaseCheckedText       for "Ready! The database was checked but no updates was needed."
    Define CS_DUF_DbUpdatedErrorText        for "One or more errors occured while the database was updated. Please check the logfile.\n\nThe program will now close."
    Define CS_DUF_UpdateInProgressTxt       for ("System locked!\n\nThe database is being updated. Please try again later...\n\n" * "The program will now close.")
    // *** cDbUpdateHandler.pkg Class Language Constants ***
    Define CS_DUF_DatabaseConnStringSpec    for "The database specified in the connection string: '"
    Define CS_DUF_DatabaseDoesntExist       for "' doesn't exist!\n\nYou need to create it with a database management software or by using the 'SqlDatabaseCreate' function, which can be used in the 'OnPreUpdate' event of the cDbUpdateHandler object.\n\nThe program will now exit."
    // *** cDbUpdateLogFile.pkg Class Language Constants ***   
    Define CS_DUF_LogFileNotFound           for "Could not locate the log file:\n\n"
#ENDIF

#IFSAME Language$Current Language$Italiano
    // *** cSQLConnectionsIniFile Class Language Constants ***
    Define CS_DUF_DuplicateConnectionIDPre  for "Cannot register connection ID"
    Define CS_DUF_DuplicateConnectionIDPost for "This ID already exists."
    // *** cSQLConnectionsHandler Class Language Constants ***
    Define CS_DUF_CannotLogincConnection    for "Cannot login to the database server as the cConnection hasn't been setup properly. Can't continue. Program will now exit."
    Define CS_DUF_CannotLoginToServer       for "Could not login to the database server. Can't continue. Program will now exit."
    Define CS_DUF_ErrorText                 for "\n\nError Text:"
    // *** cDbUpdateFunctionLibrary Class Language Constants ***
    Define CS_DUF_ConnectError              for "SQL error. Could not connect to the SQL database manager"
    Define CS_DUF_AttachError               for "Could not attach to the database:"
    Define CS_DUF_DeletingIndex             for "Deleting index"
    Define CS_DUF_CopyingData               for "Copying data"
    Define CS_DUF_CreatingIndex             for "Creating index"
    Define CS_DUF_LoginToDbServerFailed     for  "Login failed to the database server. The following connect string was used:\n"
    Define CS_DUF_DoYouWantToExit           for "Do you want to stop the database update and exit?"
    Define CS_DUF_NoIntFilesFound           for "No .int files found! Nothing was changed."
    // *** cDbUpdateVersion Class Language Constants ***
    Define CS_DUF_UpdateVersion             for "Updating database"
    Define CS_DUF_UpdateFromVersion         for "from version"
    Define CS_DUF_UpdateToVersion           for "to version:"
    Define CS_DUF_DbUpdateTableMissing      for "Cannot open the 'DbVersion' table that is used when updating the database! Cannot continue!"
    // *** cDbUpdateHandler.inc Class Language Constants ***
    Define CS_DUF_DatabaseInUseShort        for "There are others using the application/database. Are you sure you still want to update the database?"
    Define CS_DUF_DatabaseNeedsUpdate       for ("The database needs to be updated." + "\n\nATTENTION! The database may not be in use while this work is performed. Make sure that nobody else is using the application before clicking 'Yes' below.\n\n" + "Start update now?")
    Define CS_DUF_HeaderUpdateText          for "Important!"
    Define CS_DUF_DatabaseInUseText         for "There are others using the application/database or at least one table could NOT be opened exclusively. Please close all other applications using the database and try again. The Application will now close."
    Define CS_DUF_WorkingHeaderText         for "Working!"
    Define CS_DUF_WorkingUpdateText         for "The database is being updated. Please wait..."
    Define CS_DUF_DatabaseUpdatedText       for "Ready! The database was updated."
    Define CS_DUF_DatabaseCheckedText       for "Ready! The database was checked but no updates was needed."
    Define CS_DUF_DbUpdatedErrorText        for "One or more errors occured while the database was updated. Please check the logfile.\n\nThe program will now close."
    Define CS_DUF_UpdateInProgressTxt       for ("System locked!\n\nThe database is being updated. Please try again later...\n\n" * "The program will now close.")
    // *** cDbUpdateHandler.pkg Class Language Constants ***
    Define CS_DUF_DatabaseConnStringSpec    for "The database specified in the connection string: '"
    Define CS_DUF_DatabaseDoesntExist       for "' doesn't exist!\n\nYou need to create it with a database management software or by using the 'SqlDatabaseCreate' function, which can be used in the 'OnPreUpdate' event of the cDbUpdateHandler object.\n\nThe program will now exit."
    // *** cDbUpdateLogFile.pkg Class Language Constants ***   
    Define CS_DUF_LogFileNotFound           for "Could not locate the log file:\n\n"
#ENDIF

#IFSAME Language$Current Language$Espanol
    // *** cSQLConnectionsIniFile Class Language Constants ***
    Define CS_DUF_DuplicateConnectionIDPre  for "No se puede registrar conexin ID"
    Define CS_DUF_DuplicateConnectionIDPost for "Este ID ya existe."
    // *** cSQLConnectionsHandler Class Language Constants ***
    Define CS_DUF_CannotLogincConnection    for "No se puede iniciar sesin en el servidor de base de datos ya que la conexin no se ha configurado correctamente. No se puede continuar. El programa ser cerrado."
    Define CS_DUF_CannotLoginToServer       for "No se puede iniciar sesin en el servidor de base de datos. No se puede continuar. El programa ser cerrado."
    Define CS_DUF_ErrorText                 for "\n\nTexto del error:"
    // *** cDbUpdateFunctionLibrary Class Language Constants ***
    Define CS_DUF_ConnectError              for "Error SQL. No se puede conectar al administrador de base de datos SQL"
    Define CS_DUF_AttachError               for "No se puede adjuntar a la base de datos"
    Define CS_DUF_DeletingIndex             for "Eliminando ndice"
    Define CS_DUF_CopyingData               for "Copiando datos"
    Define CS_DUF_CreatingIndex             for "Creando ndice"
    Define CS_DUF_LoginToDbServerFailed     for  "Login failed to the database server. The following connect string was used:\n"
    Define CS_DUF_DoYouWantToExit           for "Do you want to stop the database update and exit?"
    Define CS_DUF_NoIntFilesFound           for "No .int files found! Nothing was changed."
    // *** cDbUpdateVersion Class Language Constants ***
    Define CS_DUF_UpdateVersion             for "Actualizando base de datos"
    Define CS_DUF_UpdateFromVersion         for "desde versin"
    Define CS_DUF_UpdateToVersion           for "hasta versin:"
    Define CS_DUF_DbUpdateTableMissing      for "No se puede abrir la tabla 'DbVersion' que se utiliza al actualizar la base de datos! No se puede continuar!"
    // *** cDbUpdateHandler.inc Class Language Constants ***
    Define CS_DUF_DatabaseInUseShort        for "There are others using the application/database. Are you sure you still want to update the database?"
    Define CS_DUF_DatabaseNeedsUpdate       for ("La base de datos necesita ser actualizada." + "\n\nNB! La base datos no puede estar en uso mientras se ejecuta esta tarea. Asegrese de que nadie ms est usando la aplicacin antes de hacer clic en 'S'.\n\n" + "Iniciar actualizacin ahora")
    Define CS_DUF_HeaderUpdateText          for "Importante!"
    Define CS_DUF_DatabaseInUseText         for "Hay otros utilizando la aplicacin / base de datos o por lo menos una tabla. No se pudo abrir exclusivamente. Cierre todas las dems aplicaciones que utilizan la base de datos y vuelva a intentarlo. La aplicacin se cerrar ahora."
    Define CS_DUF_WorkingHeaderText         for "Trabajando!"
    Define CS_DUF_WorkingUpdateText         for "a base de datos se esta actualizando. Por favor espere..."
    Define CS_DUF_DatabaseUpdatedText       for "Listo! La base de datos fue actualizada."
    Define CS_DUF_DatabaseCheckedText       for "Listo! Se verific la base de datos y no fue necesario actualizar."
    Define CS_DUF_DbUpdatedErrorText        for "Uno o ms errores ocurrieron mientras se actualizaba la base de datos. Por favor verifique el archivo de registro.\n\nEl programa ser cerrado ahora."
    Define CS_DUF_UpdateInProgressTxt       for ("Sistema bloqueado!\n\nLa base de datos est siendo actualizada. Por favor, intntelo de nuevo ms tarde...\n\n" * "El programa ser cerrado ahora.")
    // *** cDbUpdateHandler.pkg Class Language Constants ***
    Define CS_DUF_DatabaseConnStringSpec    for "The database specified in the connection string: '"
    Define CS_DUF_DatabaseDoesntExist       for "' doesn't exist!\n\nYou need to create it with a database management software or by using the 'SqlDatabaseCreate' function, which can be used in the 'OnPreUpdate' event of the cDbUpdateHandler object.\n\nThe program will now exit."
    // *** cDbUpdateLogFile.pkg Class Language Constants ***   
    Define CS_DUF_LogFileNotFound           for "Could not locate the log file:\n\n"
#ENDIF

#IFSAME Language$Current Language$Norsk
    // *** cSQLConnectionsIniFile Class Language Constants ***
    Define CS_DUF_DuplicateConnectionIDPre  for "Kan ikke registrere tilkoblings-ID"
    Define CS_DUF_DuplicateConnectionIDPost for "Denne ID-en eksisterer allerede."
    // *** cSQLConnectionsHandler Class Language Constants ***
    Define CS_DUF_CannotLogincConnection    for "Kan ikke logge på databasetjener, for cConnection er ikke riktig satt opp. Kan ikke fortsette. Programmet avsluttes."
    Define CS_DUF_CannotLoginToServer       for "Kan ikke logge på databasetjener. Kan ikke fortsette. Programmet avsluttes."
    Define CS_DUF_ErrorText                 for "\n\nFeilbeskrivelse:"
    // *** cDbUpdateFunctionLibrary Class Language Constants ***
    Define CS_DUF_ConnectError              for "SQL-feil. Kunne ikke koble til SQL-databasebehandler"
    Define CS_DUF_AttachError               for "Kunne ikke koble til database:"
    Define CS_DUF_DeletingIndex             for "Sletter indeks"
    Define CS_DUF_CopyingData               for "Kopierer data"
    Define CS_DUF_CreatingIndex             for "Oppretter indeks"
    Define CS_DUF_LoginToDbServerFailed     for  "Login failed to the database server. The following connect string was used:\n"
    Define CS_DUF_DoYouWantToExit           for "Do you want to stop the database update and exit?"
    Define CS_DUF_NoIntFilesFound           for "No .int files found! Nothing was changed."
    // *** cDbUpdateVersion Class Language Constants ***
    Define CS_DUF_UpdateVersion             for "Oppdaterer database"
    Define CS_DUF_UpdateFromVersion         for "fra versjon"
    Define CS_DUF_UpdateToVersion           for "til versjon:"
    Define CS_DUF_DbUpdateTableMissing      for "Kan ikke åpne 'DbVersion'-tabellen som brukes ved oppdatering av databasen! Kan ikke fortsette!"
    // *** cDbUpdateHandler.inc Class Language Constants ***
    Define CS_DUF_DatabaseInUseShort        for "There are others using the application/database. Are you sure you still want to update the database?"
    Define CS_DUF_DatabaseNeedsUpdate       for ("Database må oppdateres." + "\n\nNB! Databasen må ikke være i bruk mens dette pågår. Påse at ingen andre bruker databasen/programmet før du velger 'Ja' nedenfor.\n\n" + "Starte oppdatering nå?")
    Define CS_DUF_HeaderUpdateText          for "Viktig!"
    Define CS_DUF_DatabaseInUseText         for "Andre bruker programmet/databasen, eller minst en tabell kunne IKKE åpnes eksklusivt. Steng alle andre programmer som bruker databasen og forsøk igjen. Programmet avsluttes nå."
    Define CS_DUF_WorkingHeaderText         for "Arbeider!"
    Define CS_DUF_WorkingUpdateText         for "Databasen oppdateres. Vennligst vent..."
    Define CS_DUF_DatabaseUpdatedText       for "Klar! Databasen ble oppdatert."
    Define CS_DUF_DatabaseCheckedText       for "Klar! Database ble sjekket, men ingen oppdatering var nødvendig."
    Define CS_DUF_DbUpdatedErrorText        for "En eller flere feil oppsto under oppdatering av databasen. Sjekk loggfil.\n\nProgrammet avsluttes."
    Define CS_DUF_UpdateInProgressTxt       for ("System låst!\n\nDatabasen blir oppdatert. Prøv igjen senere...\n\n" * "Programmet avsluttes.")
    // *** cDbUpdateHandler.pkg Class Language Constants ***
    Define CS_DUF_DatabaseConnStringSpec    for "The database specified in the connection string: '"
    Define CS_DUF_DatabaseDoesntExist       for "' doesn't exist!\n\nYou need to create it with a database management software or by using the 'SqlDatabaseCreate' function, which can be used in the 'OnPreUpdate' event of the cDbUpdateHandler object.\n\nThe program will now exit."
    // *** cDbUpdateLogFile.pkg Class Language Constants ***   
    Define CS_DUF_LogFileNotFound           for "Could not locate the log file:\n\n"
#ENDIF

#IFSame Language$Current = Language$Russian
    // *** cSQLConnectionsIniFile Class Language Constants ***
    Define CS_DUF_DuplicateConnectionIDPre  for "Cannot register connection ID"
    Define CS_DUF_DuplicateConnectionIDPost for "This ID already exists."
    // *** cSQLConnectionsHandler Class Language Constants ***
    Define CS_DUF_CannotLogincConnection    for "Cannot login to the database server as the cConnection hasn't been setup properly. Can't continue. Program will now exit."
    Define CS_DUF_CannotLoginToServer       for "Could not login to the database server. Can't continue. Program will now exit."
    Define CS_DUF_ErrorText                 for "\n\nError Text:"
    // *** cDbUpdateFunctionLibrary Class Language Constants ***
    Define CS_DUF_ConnectError              for "SQL error. Could not connect to the SQL database manager"
    Define CS_DUF_AttachError               for "Could not attach to the database:"
    Define CS_DUF_DeletingIndex             for "Deleting index"
    Define CS_DUF_CopyingData               for "Copying data"
    Define CS_DUF_CreatingIndex             for "Creating index"
    Define CS_DUF_LoginToDbServerFailed     for "Login failed to the database server. The following connect string was used:\n"
    Define CS_DUF_DoYouWantToExit           for "Do you want to stop the database update and exit?"
    Define CS_DUF_NoIntFilesFound           for "No .int files found! Nothing was changed."
    // *** cDbUpdateVersion Class Language Constants ***
    Define CS_DUF_UpdateVersion             for "Updating database"
    Define CS_DUF_UpdateFromVersion         for "from version"
    Define CS_DUF_UpdateToVersion           for "to version:"
    Define CS_DUF_DbUpdateTableMissing      for "Cannot open the 'DbVersion' table that is used when updating the database! Cannot continue!"
    // *** cDbUpdateHandler.inc Class Language Constants ***
    Define CS_DUF_DatabaseInUseShort        for "There are others using the application/database. Are you sure you still want to update the database?"
    Define CS_DUF_DatabaseNeedsUpdate       for ("The database needs to be updated." + "\n\nATTENTION! The database may not be in use while this work is performed. Make sure that nobody else is using the application before clicking 'Yes' below.\n\n" + "Start update now?")
    Define CS_DUF_HeaderUpdateText          for "Important!"
    Define CS_DUF_DatabaseInUseText         for "There are others using the application/database or at least one table could NOT be opened exclusively. Please close all other applications using the database and try again. The Application will now close."
    Define CS_DUF_WorkingHeaderText         for "Working!"
    Define CS_DUF_WorkingUpdateText         for "The database is being updated. Please wait..."
    Define CS_DUF_DatabaseUpdatedText       for "Ready! The database was updated."
    Define CS_DUF_DatabaseCheckedText       for "Ready! The database was checked but no updates was needed."
    Define CS_DUF_DbUpdatedErrorText        for "One or more errors occured while the database was updated. Please check the logfile.\n\nThe program will now close."
    Define CS_DUF_UpdateInProgressTxt       for ("System locked!\n\nThe database is being updated. Please try again later...\n\n" * "The program will now close.")
    // *** cDbUpdateHandler.pkg Class Language Constants ***
    Define CS_DUF_DatabaseConnStringSpec    for "The database specified in the connection string: '"
    Define CS_DUF_DatabaseDoesntExist       for "' doesn't exist!\n\nYou need to create it with a database management software or by using the 'SqlDatabaseCreate' function, which can be used in the 'OnPreUpdate' event of the cDbUpdateHandler object.\n\nThe program will now exit."
    // *** cDbUpdateLogFile.pkg Class Language Constants ***   
    Define CS_DUF_LogFileNotFound           for "Could not locate the log file:\n\n"
#ENDIF

#IFSame Language$Current = Language$Polish
    // *** cSQLConnectionsIniFile Class Language Constants ***
    Define CS_DUF_DuplicateConnectionIDPre  for "Cannot register connection ID"
    Define CS_DUF_DuplicateConnectionIDPost for "This ID already exists."
    // *** cSQLConnectionsHandler Class Language Constants ***
    Define CS_DUF_CannotLogincConnection    for "Cannot login to the database server as the cConnection hasn't been setup properly. Can't continue. Program will now exit."
    Define CS_DUF_CannotLoginToServer       for "Could not login to the database server. Can't continue. Program will now exit."
    Define CS_DUF_ErrorText                 for "\n\nError Text:"
    // *** cDbUpdateFunctionLibrary Class Language Constants ***
    Define CS_DUF_ConnectError              for "SQL error. Could not connect to the SQL database manager"
    Define CS_DUF_AttachError               for "Could not attach to the database:"
    Define CS_DUF_DeletingIndex             for "Deleting index"
    Define CS_DUF_CopyingData               for "Copying data"
    Define CS_DUF_CreatingIndex             for "Creating index"
    Define CS_DUF_LoginToDbServerFailed     for  "Login failed to the database server. The following connect string was used:\n"
    Define CS_DUF_DoYouWantToExit           for "Do you want to stop the database update and exit?"
    Define CS_DUF_NoIntFilesFound           for "No .int files found! Nothing was changed."
    // *** cDbUpdateVersion Class Language Constants ***
    Define CS_DUF_UpdateVersion             for "Updating database"
    Define CS_DUF_UpdateFromVersion         for "from version"
    Define CS_DUF_UpdateToVersion           for "to version:"
    Define CS_DUF_DbUpdateTableMissing      for "Cannot open the 'DbVersion' table that is used when updating the database! Cannot continue!"
    // *** cDbUpdateHandler.inc Class Language Constants ***
    Define CS_DUF_DatabaseInUseShort        for "There are others using the application/database. Are you sure you still want to update the database?"
    Define CS_DUF_DatabaseNeedsUpdate       for ("The database needs to be updated." + "\n\nATTENTION! The database may not be in use while this work is performed. Make sure that nobody else is using the application before clicking 'Yes' below.\n\n" + "Start update now?")
    Define CS_DUF_HeaderUpdateText          for "Important!"
    Define CS_DUF_DatabaseInUseText         for "There are others using the application/database or at least one table could NOT be opened exclusively. Please close all other applications using the database and try again. The Application will now close."
    Define CS_DUF_WorkingHeaderText         for "Working!"
    Define CS_DUF_WorkingUpdateText         for "The database is being updated. Please wait..."
    Define CS_DUF_DatabaseUpdatedText       for "Ready! The database was updated."
    Define CS_DUF_DatabaseCheckedText       for "Ready! The database was checked but no updates was needed."
    Define CS_DUF_DbUpdatedErrorText        for "One or more errors occured while the database was updated. Please check the logfile.\n\nThe program will now close."
    Define CS_DUF_UpdateInProgressTxt       for ("System locked!\n\nThe database is being updated. Please try again later...\n\n" * "The program will now close.")
    // *** cDbUpdateHandler.pkg Class Language Constants ***
    Define CS_DUF_DatabaseConnStringSpec    for "The database specified in the connection string: '"
    Define CS_DUF_DatabaseDoesntExist       for "' doesn't exist!\n\nYou need to create it with a database management software or by using the 'SqlDatabaseCreate' function, which can be used in the 'OnPreUpdate' event of the cDbUpdateHandler object.\n\nThe program will now exit."
    // *** cDbUpdateLogFile.pkg Class Language Constants ***   
    Define CS_DUF_LogFileNotFound           for "Could not locate the log file:\n\n"
#ENDIF

#IFSame Language$Current = Language$Hungarian
    // *** cSQLConnectionsIniFile Class Language Constants ***
    Define CS_DUF_DuplicateConnectionIDPre  for "Cannot register connection ID"
    Define CS_DUF_DuplicateConnectionIDPost for "This ID already exists."
    // *** cSQLConnectionsHandler Class Language Constants ***
    Define CS_DUF_CannotLogincConnection    for "Cannot login to the database server as the cConnection hasn't been setup properly. Can't continue. Program will now exit."
    Define CS_DUF_CannotLoginToServer       for "Could not login to the database server. Can't continue. Program will now exit."
    Define CS_DUF_ErrorText                 for "\n\nError Text:"
    // *** cDbUpdateFunctionLibrary Class Language Constants ***
    Define CS_DUF_ConnectError              for "SQL error. Could not connect to the SQL database manager"
    Define CS_DUF_AttachError               for "Could not attach to the database:"
    Define CS_DUF_DeletingIndex             for "Deleting index"
    Define CS_DUF_CopyingData               for "Copying data"
    Define CS_DUF_CreatingIndex             for "Creating index"
    Define CS_DUF_LoginToDbServerFailed     for  "Login failed to the database server. The following connect string was used:\n"
    Define CS_DUF_DoYouWantToExit           for "Do you want to stop the database update and exit?"
    Define CS_DUF_NoIntFilesFound           for "No .int files found! Nothing was changed."
    // *** cDbUpdateVersion Class Language Constants ***
    Define CS_DUF_UpdateVersion             for "Updating database"
    Define CS_DUF_UpdateFromVersion         for "from version"
    Define CS_DUF_UpdateToVersion           for "to version:"
    Define CS_DUF_DbUpdateTableMissing      for "Cannot open the 'DbVersion' table that is used when updating the database! Cannot continue!"
    // *** cDbUpdateHandler.inc Class Language Constants ***
    Define CS_DUF_DatabaseInUseShort        for "There are others using the application/database. Are you sure you still want to update the database?"
    Define CS_DUF_DatabaseNeedsUpdate       for ("The database needs to be updated." + "\n\nATTENTION! The database may not be in use while this work is performed. Make sure that nobody else is using the application before clicking 'Yes' below.\n\n" + "Start update now?")
    Define CS_DUF_HeaderUpdateText          for "Important!"
    Define CS_DUF_DatabaseInUseText         for "There are others using the application/database or at least one table could NOT be opened exclusively. Please close all other applications using the database and try again. The Application will now close."
    Define CS_DUF_WorkingHeaderText         for "Working!"
    Define CS_DUF_WorkingUpdateText         for "The database is being updated. Please wait..."
    Define CS_DUF_DatabaseUpdatedText       for "Ready! The database was updated."
    Define CS_DUF_DatabaseCheckedText       for "Ready! The database was checked but no updates was needed."
    Define CS_DUF_DbUpdatedErrorText        for "One or more errors occured while the database was updated. Please check the logfile.\n\nThe program will now close."
    Define CS_DUF_UpdateInProgressTxt       for ("System locked!\n\nThe database is being updated. Please try again later...\n\n" * "The program will now close.")
    // *** cDbUpdateHandler.pkg Class Language Constants ***
    Define CS_DUF_DatabaseConnStringSpec    for "The database specified in the connection string: '"
    Define CS_DUF_DatabaseDoesntExist       for "' doesn't exist!\n\nYou need to create it with a database management software or by using the 'SqlDatabaseCreate' function, which can be used in the 'OnPreUpdate' event of the cDbUpdateHandler object.\n\nThe program will now exit."
    // *** cDbUpdateLogFile.pkg Class Language Constants ***   
    Define CS_DUF_LogFileNotFound           for "Could not locate the log file:\n\n"
#ENDIF
